/* Funktion Mittelwertbildung  und diverse LCD-Ausgaben, 2 verschiedene Mittelwerte mit taster P2.2 berechnet
 * Bei der Projekterstellung muss ein Haken bei sprintf-Funtkionen einbinden gemacht werden!!!*/
#include <XMC1100-Lib.h>						// Hilfsfunktionen für XMC1100
#include <stdio.h>								// für sprintf

#define anzahlwerte 5							// Anzahl der Werte, unten alternative Berechnung mit sizeof
uint8_t werte1[]= {8,9,10,11,12};				// die ersten 5 Werte
uint8_t werte2[]= {3,4,5,6,7,8};				// die zweiten 5 Werte
uint8_t ergebnis;								// Ergebnisspeicher
char lcdtext[20];								// für sprintf und LCD-Ausgabe

//-------------------- Funktion zur Mittelwertberechnung ------------------------------------------------
// Übergabe: Array der Werte, von denen der Mittelwert berechnet werden soll und Anzahl der Werte
// Achtung Ergebnis ist eine ganze Zahl!
uint8_t mittelwert (uint8_t *arr, uint8_t anzahl)
{
	uint8_t i;
	uint16_t sum=0;
	uint8_t mw;
	for (i=0;i<anzahl;++i) sum += arr[i];			// Summe der Werte
	mw = sum / anzahl;								// geteilt durch Anzahl ist Mittelwert
	return (uint8_t) mw;
}
//--------------------- Hauptprogramm -------------------------------------------------------------------
int main(void)										// Hauptprogramm
{ uint8_t i,anz;
  port_init(P0,OUTP);								// Port0 auf Ausgabe
  bit_init(P2,2,INP);								// Taster ganz rechts
  delay_ms(500);									// warten bis LC bereit
  lcd_init();										// LC-Display initialisieren
  lcd_setcursor (1,1);								// in 1. Zeile ganz links
  lcd_print ("Der Mittelwert von");					// erklärenden Text ausgeben
  while(1U)											// Endlosschleife Hauptprogramm
  {
	  lcd_setcursor (2,1);							// in 2. Zeile die Werte schreibe
	  if (bit_read(P2,2)==0)
		  {
		  anz = sizeof (werte1)/sizeof (werte1[0]);	//Anzahl der Werte im Array berechnen
		  ergebnis = mittelwert (werte1,anz);		// Mittelwert berechnen
		  for (i=0;i<anz;++i) lcd_byte (werte1[i]);	// einzelne Werte anzeigen, Maximal 6 pro LCD-Zeile
		  }
	  else
		  {
		  ergebnis = mittelwert (werte2,anzahlwerte);
		  for (i=0;i<anzahlwerte;++i) lcd_byte (werte2[i]);
		  }
	  port_write(P0,ergebnis);						// Ergebnis an LEDs anzeigen
	  lcd_setcursor (3,1);							// 3. Zeile
	  sprintf (lcdtext,"ist %d   ",ergebnis);		// Anzeigetext erzeugen
	  lcd_print (lcdtext);							// und anzeigen
  }//while
}//main
