/* Funktion Mittelwertbildung  und diverse LCD-Ausgaben,
 * ohne Tastendruck -> Mittelwert von werte2: fest eingegebene Zahlen
 * mit Tasterendruck P2.2 Mittelwert von 5 ADC-Werten des Poti links
 * Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!!*/
#include <XMC1100-Lib.h>						// Hilfsfunktionen für XMC1100
#include <stdio.h>								// für sprintf

#define anzahlwerte 5							// Anzahl der Werte (max.6 wegen LC-Anzeige der einzelnen Werte)
uint8_t werte1[anzahlwerte];					// die ersten 5 Werte werden später vom Poti links geliefert
uint8_t werte2[]= {3,4,5,6,7,8};				// die zweiten 5 Werte
uint8_t ergebnis;								// Ergebnisspeicher
char lcdtext[20];								// für sprintf und LCD-Ausgabe

//-------------------- Funktion zur Mittelwertberechnung ------------------------------------------------
// Übergabe: Array der Werte, von denen der Mittelwert berechnet werden soll und Anzahl der Werte
// Achtung Ergebnis ist eine ganze Zahl!
uint8_t mittelwert (uint8_t *arr, uint8_t anzahl)
{
	uint8_t i;										// Zähler
	uint16_t sum=0;									// Summe Achtung "größere" Variable notwendig!!!
	uint16_t mw;									// Mittelwert
	for (i=0;i<anzahl;++i) sum += arr[i];			// Summe der Werte
	mw = sum / anzahl;								// geteilt durch Anzahl ist Mittelwert
	return (uint8_t) mw;							// Rückgabewert umwandeln in 8-Bit
}
//--------------------- Hauptprogramm -------------------------------------------------------------------
int main(void)										// Hauptprogramm
{ uint8_t i;
  port_init(P0,OUTP);								// Port0 auf Ausgabe
  bit_init(P2,2,INP);								// Taster ganz rechts
  adc_init();										// Analoge Eingänge initialisieren
  delay_ms(500);									// warten bis LC bereit
  lcd_init();										// LC-Display initialisieren
  lcd_setcursor (1,1);								// in 1. Zeile ganz links
  lcd_print ("Der Mittelwert von");					// erklärenden Text ausgeben
  while(1U)											// Endlosschleife Hauptprogramm
  {   for (i=0; i<anzahlwerte;++i) {				// im Abstand von 100ms 5 Werte
	  werte1[i] = adc_in(3)>>4;						// einlesen und aus 12Bit >> 8 Bit machen
	  delay_ms(100);								//
  	  }
	  lcd_setcursor (2,1);							// in 2. Zeile die Werte schreibe
	  if (bit_read(P2,2)==0)						// Taster gedrückt? (lowaktiv)
		  {
		  ergebnis = mittelwert (werte1,anzahlwerte);		// Mittelwert berechnen
		  for (i=0;i<anzahlwerte;++i) lcd_byte (werte1[i]);	// einzelne Werte anzeigen, Maximal 6 pro LCD-Zeile
		  }
	  else
		  {
		  ergebnis = mittelwert (werte2,anzahlwerte);		// Mittelwert berechnen
		  for (i=0;i<anzahlwerte;++i) lcd_byte (werte2[i]);
		  }
	  port_write(P0,ergebnis);						// Ergebnis an LEDs anzeigen
	  lcd_setcursor (3,1);							// 3. Zeile
	  sprintf (lcdtext,"ist %d   ",ergebnis);		// Anzeigetext erzeugen
	  lcd_print (lcdtext);							// und anzeigen
  }//while
}//main
