/* Funktion Mittelwertbildung  und diverse LCD-Ausgaben,
 * ohne Tastendruck -> gleitender Mittelwert iwerte von 5 ADC-Werten des Poti rechts
 * mit Tasterendruck P2.2 -> gleitender Mittelwert von 5 ADC-Werten des Poti links
 * Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!!*/
#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
#include <stdio.h>					// für sprintf

#define anzahlwerte 5							// Anzahl der Werte (max.6 wegen LC-Anzeige der einzelnen Werte)
uint8_t u_werte[anzahlwerte];					// die ersten 5 Werte werden später vom Poti links geliefert
uint8_t i_werte[anzahlwerte];					// die zweiten 5 Werte
uint8_t ergebnis;								// Ergebnisspeicher
char lcdtext[20];								// für sprintf und LCD-Ausgabe
uint8_t adc_wert;

//-------------------- Funktion zur Mittelwertberechnung ------------------------------------------------
// Übergabe: Array der Werte, von denen der Mittelwert berechnet werden soll und Anzahl der Werte
// Achtung Ergebnis ist eine ganze Zahl!
uint8_t mittelwert (uint8_t *arr, uint8_t anzahl,uint8_t aktualwert)
{
	uint8_t i;										// Zähler
	uint16_t sum=0;									// Summe Achtung "größere" Variable notwendig!!!
	uint16_t mw;									// Mittelwert
	for (i=0;i<anzahl-1;++i) arr[i]= arr[i+1];		// alte Messwerte um 1 Stelle im Speicher verschieben, ältester Messwert entfällt
	arr[anzahl-1] = aktualwert;						// neuester Messwert in den Speicher
	for (i=0;i<anzahl;++i)	sum += arr[i];			// letzte <anzahl> Messwerte aufaddieren
	mw = sum / anzahl;								// geteilt durch Anzahl ist Mittelwert
	return (uint8_t) mw;							// Rückgabewert umwandeln in 8-Bit
}

int main(void)						// Hauptprogramm
{
  uint8_t i;
  port_init(P0,OUTP);								// Port0 auf Ausgabe
  bit_init(P2,2,INP);								// Taster ganz rechts
  adc_init();										// Analoge Eingänge initialisieren
  delay_ms(500);									// warten bis LC bereit
  lcd_init();										// LC-Display initialisieren
  lcd_setcursor (1,1);								// in 1. Zeile ganz links
  lcd_print ("Der Mittelwert von");					// erklärenden Text ausgeben
  while(1U)											// Endlosschleife Hauptprogramm
  {
	  lcd_setcursor (2,1);							// in 2. Zeile die Werte schreibe
	  if (bit_read(P2,2)==0)						// Taster gedrückt? (lowaktiv)
		  {
		  adc_wert = adc_in(0)>>4;
		  ergebnis = mittelwert (u_werte,anzahlwerte,adc_wert);		// gleitenden Mittelwert berechnen
		  for (i=0;i<anzahlwerte;++i) lcd_byte (u_werte[i]);	// einzelne Werte anzeigen, Maximal 6 pro LCD-Zeile
		  }
	  else
		  {
		  adc_wert = adc_in(1)>>4;
		  ergebnis = mittelwert (i_werte,anzahlwerte,adc_wert);		// gleitenden Mittelwert berechnen
		  for (i=0;i<anzahlwerte;++i) lcd_byte (i_werte[i]);
		  }
	  port_write(P0,ergebnis);						// Ergebnis an LEDs anzeigen
	  lcd_setcursor (3,1);							// 3. Zeile
	  sprintf (lcdtext,"ist %d   ",ergebnis);		// Anzeigetext erzeugen
	  lcd_print (lcdtext);							// und anzeigen
  }//while
}//main
