/* U,I,P-Messung Solarzellen
 * Rlast = 22 Ohm und 100 Ohm-Poti und 1,8 Ohm-Strommesswiderstand in Reihe
 * Solarzelle auf Holzbrett GDS2 C=1000µF parallel zur Solarzelle
 * Bei der Projekterstellung muss ein Haken bei sprintf-Funktionen einbinden gemacht werden!!!*/
#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
#include <stdio.h>					// für sprintf

#define kanal_u 4		// normal 4 -> P2.11, für Programmtest mit Poti nehme 0
#define kanal_i 3		// normal 3 -> P2.10, für Programmtest mit Poti nehme 1
#define anzahlwerte 20							// Anzahl der Werte (max.6 wegen LC-Anzeige der einzelnen Werte)
#define r_shunt 1.8								// Strommesswiderstand
uint16_t u_werte[anzahlwerte];					// Array für Spannungswerte
uint16_t i_werte[anzahlwerte];					// Array für Stromwerte
uint16_t mw_u,mw_i;								// Ergebnisspeicher für Mittelwerte
char lcdtext[20];								// für sprintf und LCD-Ausgabe
uint16_t adc_u,adc_i;							// von den ADC engelesene Werte
float u_float, i_float, p_float;

//-------------------- Funktion zur Mittelwertberechnung ------------------------------------------------
// Übergabe: Array der Werte, von denen der Mittelwert berechnet werden soll und Anzahl der Werte
// Achtung Ergebnis ist eine ganze Zahl!
uint16_t mittelwert (uint16_t *arr, uint8_t anzahl,uint16_t aktualwert)
{
	uint8_t i;										// Zähler
	uint32_t sum=0;									// Summe Achtung "größere" Variable notwendig!!!
	uint32_t mw;									// Mittelwert
	for (i=0;i<anzahl-1;++i) arr[i]= arr[i+1];		// alte Messwerte um 1 Stelle im Speicher verschieben, ältester Messwert entfällt
	arr[anzahl-1] = aktualwert;						// neuester Messwert in den Speicher
	for (i=0;i<anzahl;++i)	sum += arr[i];			// letzte <anzahl> Messwerte aufaddieren
	mw = sum / anzahl;								// geteilt durch Anzahl ist Mittelwert
	return  (uint16_t) mw;							// Rückgabewert umwandeln in 16-Bit
}
//-------------------- Hauptprogramm -----------------------------------------------------------------------
int main(void)
{
  uint8_t i;
  port_init(P0,OUTP);								// Port0 auf Ausgabe
  adc_init();										// Analoge Eingänge initialisieren
  adc_u = adc_in(kanal_u);
  for (i=0;i<anzahlwerte;i++) u_werte[i]=adc_u;		// Messwert-Arrays initialisieren,
  adc_i = adc_in(kanal_i);
  for (i=0;i<anzahlwerte;i++) i_werte[i]=adc_i;	    //
  delay_ms(500);									// warten bis LC bereit
  lcd_init();										// LC-Display initialisieren
  while(1U)											// Endlosschleife Hauptprogramm
  {

	  adc_u = adc_in(kanal_u);
	  mw_u = mittelwert (u_werte,anzahlwerte,adc_u);		// gleitenden Mittelwert berechnen
	  u_float = 5.0/4096 * mw_u;							// Spannung berechnen
	  sprintf (lcdtext,"U = %4.3f V ",u_float);				// Ausgabetext erzeugen
	  lcd_setcursor (1,1);
	  lcd_print (lcdtext);									// anzeigen
	  adc_i = adc_in(kanal_i);
	  mw_i = mittelwert (i_werte,anzahlwerte,adc_i);		// gleitenden Mittelwert berechnen
	  i_float = 5.0/4096 * mw_i/r_shunt;					// normieren auf 5V und i berechnen
	  sprintf (lcdtext,"I = %4.3f A ",i_float);
	  lcd_setcursor (2,1);
	  lcd_print (lcdtext);									// anzeigen
	  p_float = u_float * i_float;							// Leistung der Mittelwerte berechnen
	  sprintf (lcdtext,"P = %4.3f W ",p_float);
	  lcd_setcursor (3,1);
	  lcd_print (lcdtext);									// anzeigen
	  delay_ms(50);											// Bestimmt die Geschwindigkeit der Messungen
  }//while
}//main
